' FileName: DVWin.Bas
' Date: 1/1/2017
' Author: Ben Ritchey
' Description: DASD Vision File Manager (WinXP/Vista/7/8/10)

#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

DECLARE FUNCTION TextInput(TCol as Long, CurFile AS STRING, Buffer AS STRING, _
                        Row AS LONG, Col AS LONG, History() AS STRING) AS LONG

FUNCTION PBMAIN () AS LONG  '        (c) 2018 Ben Ritchey

  Local ZZ, A, C, F, CC, CName, Drv, DrvList, DVol, Saveit, Z as String
  Local AA, B, D, SizeS, FstData, CX, CY, H, HH, I, II, K, KK, L, LL as Long
  Local AD, AC as Double
  Local TFlag, RLeg, TDDT, FAttr, LLen, M, T, TCol, TRow as Long
  Local DirDataTab() as String
  LOCAL MONTHTAB() AS STRING
  Local EFlag, SFlag, VFlag, PName, PgmVer, SubDir, TBytes, BFree as string
  Local FTTab, TStore, ZDesc, CFSuf, DFSuf, PLeft, PRite, TDir as string
  Local Red, Yellow, Green, Blue, Violet, White, Black, Grey, Cyan as Long
  Local HRed, HYellow, HGreen, HBlue, HViolet, HWhite, HBlack, HCyan as Long
  Local RC as integer
  Local Elapsed, TStores, EStores, DStores, ElapMins, ElapSecs as Long
  Local XFlag, TimerFlag, Row, Column, MaxRow, MaxCol as Long
  Local ConText, EStore AS STRING
  Local FTTMax, FTTIdx, Idler, TDFlag, Bell, KeyCo as Long

  LOCAL CPUs, CurFile, buffer AS STRING
  LOCAL CurPos AS LONG
  LOCAL BitShift, retVal AS LONG
  LOCAL ti      AS LONG

  REDIM history1(0) AS STRING  'add a history array for each text field if needed.

' Do NOT change format of next line except x-x !!!
  PgmVer=" DVWin v2.3.L "

  CName=Environ$("COMPUTERNAME")
  CPUs=Environ$("NUMBER_OF_PROCESSORS")
  TDir=Environ$("TEMP")
  RC=0  ' Exit Errorlevel (Return code)
  SFLag="N"  ' N ame, -D ate new, -S ize big
  EFlag="DVWEdit.Bat "
  VFlag="DVWView.Bat "
  TFlag=0  ' Type when ON=1
  TDFlag=0  ' Exit Dir when On=1
  Idler=120  ' Extra warning beeps after n secs
  TRow=60  ' Screen Rows
  TCol=132  ' Screen Columns
  TDDT=10000  ' Directory Table size = 10,000
  Red=4: Yellow=6: Green=2: Blue=1: Violet=5: White=7: Black=0: Grey=8: Cyan=3
  HRed=12: HYellow=14: HGreen=10: HBlue=9: HViolet=13: HWhite=15: HCyan=11
  KeyCo=White
  FTTab=".LOG.TXT.BAS.ASM.PAS.C  .C# .C++.PL .MTX.HTM.BBS.RPT.CSV"
    FTTab=FTTab+".INI.BAT.PRT.LST.ASC.ANS.MTX.XML.ION.FAQ.MHT.REG"
    FTTab=FTTab+".XED.WCC.DIZ.REF.FAR.INC.H  "

'  DIM DirDataTab(TDDT)
  Dim MonthTab(12)

  A=ucase$(command$, ANSI)
  Drv="C"  ' default Work drive
  B=instr(A,":")
  If B>1 then Drv=mid$(A,B-1,1)  ' override drive if d:

  ZDesc="Google_Search"
  B=instr(A,"Z=")
  If B>0 then  '              override desc if Z=x-x
    ZDesc=extract$(mid$(command$,B+2), ANY " "+chr$(34)+chr$(13))
  End if
  If len(ZDesc)<15 then ZDesc=ZDesc+space$(15-len(ZDesc))
  If len(ZDesc)>15 then ZDesc=mid$(ZDesc,1,15)

  Bell=0: If instr(A,"/B") then Bell=1

  TimerFlag=0: If instr(A,"/T") then TimerFlag=1

  B=instr(A,"R=")
  If B>0 then TRow=val(mid$(A,B+2))  ' override Rows if R=nn
  If TRow<60 then TRow=60
  If TRow>100 then TRow=60

  B=instr(A,"C=")
  If B>0 then TCol=val(mid$(A,B+2))  ' override Cols if C=nnn
  If TCol<132 then TCol=132
  If TCol>240 then TCol=132

'  B=instr(A,"/TOP")
'  If B>0 then shell "cmd /c cmdow.exe "+chr$(34)+"DASD Vision for Windows"+chr$(34)+" /TOP"

  RLeg=TRow-4  ' Legend Row
  PLeft=chr$(176)+chr$(176)+chr$(177)+chr$(177)+chr$(178)+chr$(178)
  PRite=chr$(178)+chr$(178)+chr$(177)+chr$(177)+chr$(176)+chr$(176)
  If not TCol<140 then
    PLeft=string$(4,chr$(176))+string$(3,chr$(177))+string$(2,chr$(178))
    PRite=string$(2,chr$(178))+string$(3,chr$(177))+string$(4,chr$(176))
  End if
  PName=" "+PLeft+"  DASD Vision File Manager for MS-Windows  "+PRite+" "

  If isfolder(Drv+":\")=0 then Drv="C": beep  ' Work drive validation
  If isfolder(TDir)=0 then TDir=""
  If TDir="" then TDir=Drv+":\$DVWin$" else TDir=TDir+"\$DVWin$"

  DrvList="C": On Error Resume Next
  for L=68 to 90
    ChDrive Chr$(L)
    If Err=0 then DrvList=DrvList+" "+Chr$(L): else Errclear
   Next L 
  On Error Goto 0
  ChDrive "C"

  FOR L=1 TO 12
    MONTHTAB(L)=READ$(L)
  NEXT L

Startup:

  Shell "cmd /c mode con cols="+Trim$(Str$(TCol))+" lines="+trim$(str$(TRow))
  Console set screen TRow, TCol

reDIM DirDataTab(TDDT)

Shell "Cmd /c Dir /A:-S /O:G"+SFlag+" /X >"+TDir  ' Main Files/Dir search

Open TDir for Input as #1

B=1
If K<1 then K=1
If K>=T then K=1
LLen=0: DVol=""
While not Eof(1)
  Line Input #1,A
  If Instr(A,"<DIR>")>0 and Instr(A," .")>0 then goto LoadNext
  If A<>"" and mid$(A,1,1)<>" " then
    If Mid$(A,3,1)="/" then Mid$(A,3,1)="-"
    If Mid$(A,6,1)="/" then Mid$(A,6,1)="-"
    If Mid$(A,1,1)="0" then Mid$(A,1,1)=" "
    If Mid$(A,13,1)="0" and Mid$(A,14,1)<>"0" then Mid$(A,13,1)=" "
    If Mid$(A,20,1)="M" then Mid$(A,20,1)="m"
    If instr(A,"$DVWin$")=0 then DirDataTab(B)=A: B=B+1  ' Add file to table
    If LLen<len(A) then LLen=len(A)+1
  End if

  l=instr(a,"Directory of")
  if l>0 then SubDir=Trim$(mid$(a,l+13))

  l=instr(a," File(s) ")
  if l>0 then TBytes=mid$(a,l+8)

  l=instr(a," bytes free")
  if l>0 then
    m=instr(a,"Dir(s)")
    BFree=mid$(a,m+6): BFree=RTrim$(BFree," bytes free")
  End if

  l=instr(a," Volume in drive ")
  if l>0 then DVol=Trim$(mid$(a,23))

LoadNext:

If B>=TDDT-3 then
  Shell "Cmd /C Beep": gosub mybeep
  If TDFlag=1 then TDFlag=0: ChDir "..": Goto Startup

  Cls
  Print
  Print "*************************************************************"
  Print "*                                                           *"
  Print "            -=:{ Warning: Too many entries ! }:=-            "
  Print "*                                                           *"
  Print "  List truncated to 1st ";B-1;" files.                       "
  Print "*                                                           *"
  Print "*************************************************************"
  Print
  Print "  press {Enter} key";
  Shell "Cmd /C Beep"
  Input A
  TDFlag=1
  Print
  Goto EndTab
End if

WEnd

TDFlag=0

EndTab:
Close 1
T=B ' Last Record index (::EOF)
DirDataTab(T)="::EOF"

If DVol="" then DVol="{none}"

B=1: I=K: SizeS=TRow-20: Z=""

NextScr:
K=I

GoSub NewScr

  Locate RLeg,7
  Color HYellow,Black: Print mid$(Subdir,1,2);
  Color Yellow,Blue: Print " Bytes free= ";

  AD=diskfree(mid$(Subdir,1,1)): DFSuf="Bytes"
  If AD>1000 then AD=AD/1000: DFSuf="KB"
  If AD>1000 then AD=AD/1000: DFSuf="MB"
  If AD>1000 then AD=AD/1000: DFSuf="GB"
  If AD>1000 then AD=AD/1000: DFSuf="TB"
  If AD>1000 then AD=AD/1000: DFSuf="PB"
  If AD>1000 then AD=AD/1000: DFSuf="EB"

  AC=disksize(mid$(Subdir,1,1)): CFSuf="Bytes"
  If AC>1000 then AC=AC/1000: CFSuf="KiloBytes"
  If AC>1000 then AC=AC/1000: CFSuf="MegaBytes"
  If AC>1000 then AC=AC/1000: CFSuf="GigaBytes"
  If AC>1000 then AC=AC/1000: CFSuf="TeraBytes"
  If AC>1000 then AC=AC/1000: CFSuf="PetaBytes"
  If AC>1000 then AC=AC/1000: CFSuf="ExaBytes"
  Color HYellow,Black: Print using$("###.##",AD);
  Color Yellow,Blue: Print " ";DFSuf;"  (";
  Color HYellow,Black: Print trim$(str$(int(((AD/AC)*100)+.5)));: Print "%";
  Color Yellow,Blue: Print " of ";
  Color HYellow,Black: Print using$("###.##",AC);
  Color Yellow,Blue: Print " ";CFSuf;")";

  Locate 4,1
  Color Red,Black: Print "  ";: Print Using$("####",T-1);
  Color White,Black: Print "   Directory of ";
  Color HCyan,Black: Print Space$(TCol-22);
  Locate 5,1: Print space$(TCol);
  Locate 4,23: Print " ";SubDir;" ";
  Color White,Blue

  If T=1 or instr(SFlag,"/A:")>0 then
   If T=1 then Color Red,Black: Print " NO files {empty!} ";
   Color HWhite,Blue
   If instr(sflag,":R") then Color Red: Print "   Read Only files ... HOME to reset ";
   If instr(sflag,":H") then Color Red: Print "   HIDden files ... HOME to reset ";
   If instr(sflag,":S") then Color Red: Print "   SYStem files ... HOME to reset ";
  End if

  Locate RLeg,TCol-14: Color Yellow,Blue
  Print "  Work=";: Color HYellow,Black: Print Drv;":"

  Locate RLeg,TCol-64-Len(DrvList)
rem  Color Yellow,Blue: Print "Alt+Q: ";  ' Alt+Q Dec 0+16 unused
rem  Color Black,Blue: If XFlag=0 then color Red: Print "Off"; else color HGreen,Black: print "On ";
  Color Yellow,Blue: Print "  Window: ";
  Color HYellow,Black: Print trim$(str$(TCol));"x";trim$(str$(TRow));
  Color Yellow,Blue: Print "    Available Drives: ";
  Color HYellow,Black: Print DrvList

  Locate 2,8
  Color Yellow,White
  Print " Volume ID: ";
  Color HBlue,White
  Print " ";DVol;" "
  Print
  If T=1 then goto getfunc

  Locate 6,1
  Color Blue,White
  Print space$(TCol);
  Locate 6,1: Color Yellow,White
  Print "     #     Date       Time          Bytes       Short FN     Long File Name ";
  If LLen-60>=44 then Print space$(41); else Print space$(LLen-69);
  Print "   ARHS     #"
  Color Yellow,Blue
  Print string$(TCol-1,chr$(196));: Locate ,1
  Print chr$(214);
  Locate ,7: Print " "; ' chr$(213);string$(2,chr$(196));chr$(184);
  Print " ";chr$(218);string$(8,chr$(196));chr$(191);
  Print "  ";chr$(218);string$(6,chr$(196));chr$(191);
  Print "  ";chr$(218);string$(14,chr$(196));chr$(191);
  Print " ";chr$(218);string$(10,chr$(196));chr$(191);
  Print " ";chr$(218);string$(14,chr$(196));chr$(16);" ";
  Locate ,TCol: print chr$(183);
  Color White,Blue

  FstData=CursorY-1  ' Start of Files section ... (see HiLite routines)

While DirDataTab(I)<>"::EOF" and B<=SizeS
  A=DirDataTab(I): B=B+1: I=I+1
  Color Yellow
  Print chr$(186);
  If instr(a,"<DIR>")>0 then Color Yellow else Color White
  Print " ";Using$("####",I-1);
  If instr(a,"<DIR>")>0 then Color HCyan else Color HWhite
  Print "  ";

  If len(A)>=TCol-22 then Print mid$(A,1,TCol-22);: else Print A;
  Color Yellow,Blue
  If len(A)<TCol-22 and LLen<TCol-22 then 
    Print string$(LLen-len(A),250);
   Else
    Print string$(TCol-22-len(A),250);
  End if

    GoSub DoAttr  ' Display ARHS attributes
    If instr(a,"<DIR>")>0 then Color Yellow else Color White
    Print "  ";Using$("####",I-1);" ";
    Color Yellow: locate ,TCol: print chr$(186);
  Color White

BadData:
Wend  

KK=I-K-1
CY=CursorY
If I>=T then
  Color Yellow
  Print String$(TCol,chr$(205));
  Locate CY,9: Print chr$(181);
  Locate CY,54: Print chr$(198);
  Locate ,TCol: Print chr$(188);
End if

Color Yellow,Blue
Locate CY,1
Print chr$(200);
Color White,Blue
If I>=T then
  Locate CY,10
  Color Yellow: Print " Total sub-dir alloc= ";
  Color HYellow,Black: Print TBytes;: Color Yellow,Blue: Print " ";
  Locate CY,47: Color Yellow: Print " bytes ";
 Else
  Color Yellow: Locate CY,52
  Print "  . . .  ";chr$(25);"  c o n t i n u e d  ";chr$(25);
  Locate ,TCol: print chr$(188);
End if

Color White,Blue

If H<1 or H>=T or H>SizeS OR H>T-K then H=1 ' Reset current line?

Gosub HiLite

GetFunc:

Locate RLeg+1,1
Color Black,Cyan
Print space$((TCol*4)-0);

locate RLeg+1,2
L=0: If TCol>132 then L=(TCol-132)/2

Print space$(L);
Color Black: Print " Scroll=";: Color KeyCo: Print "PgUp";
Color Black: Print "/";: Color KeyCo: Print "PgDown";
Color Black: Print "/";: Color KeyCo: Print "Home";
Color Black: Print "/";: Color KeyCo: Print "End";
Color Black: Print "/";: Color KeyCo: Print chr$(24);chr$(25);
Color Black: Print "  ";

Color KeyCo: Print "Ins";: Color Black: Print "/";
Color KeyCo: Print "Chars";: Color Black: Print "=CMD  ";
Color KeyCo: Print "F2";: Color Black: Print "=Exec  ";
Color KeyCo: Print "SPace";: Color Black: Print "=Mark  ";
Color KeyCo: Print "F8";: Color Black: Print "=Do Marks ";
Color KeyCo: Print " Home";: Color Black: Print "=Reset All  ";
Color KeyCo: Print "F9";: Color Black: Print "=Drive  ";
Color KeyCo: Print "F3";: Color Black: Print "=Exit  ";
Color KeyCo: Print "Alt+V";: Color Black: Print "=VTerm"

Print space$(L);
Color Black: Print "   Attr:";
Color KeyCo: Print "F5";: Color Black: Print "=R/O, ";
Color KeyCo: Print "F6";: Color Black: Print "=HIDden, ";
Color KeyCo: Print "F7";: Color Black: Print "=SYStem  Sort:";
Color KeyCo: Print "F10";: Color Black: Print "=Name, ";
Color KeyCo: Print "F11";: Color Black: Print "=Date, ";
Color KeyCo: Print "F12";: Color Black: Print "=Size  ";
Color KeyCo: Print "Enter";: Color Black: Print "/";
Color KeyCo: Print chr$(16);: Color Black: Print "=EDit or CD <DIR> ";
Color KeyCo: Print " Esc";: Color Black: Print "/";
Color KeyCo: Print chr$(17);: Color Black: Print "=CD ..  ";
Color KeyCo: Print "F4";: Color Black: Print "=View  ";
Color KeyCo: Print "Tab";: Color Black: Print "=+10";

GoSub DoHelp

DoKeyNext:                              ' Idle loop ********

Locate SizeS+9,1
Cursor OFF
C=""
If instr(UCase$(command$),"/E") then 
  L=Timer+1800  ' Auto-exit after 30 mins
 Else
  L=0  ' Auto-exit OFF
End if

While C=""
 Gosub DOTOD: If L>0 and Timer>=L then goto Enditall
 If Instat=0 then Sleep 45 else C=Inkey$: BitShift=INSHIFT
WEnd

Cursor ON, 100

Stackit:

If len(C)=2 then
  if mid$(C,2,1)=chr$(72) then   ' Up arw
    If Bit(BitShift,1) or Bit(BitShift,4) then ' Left-Alt or Shift?
      H=1: goto Startup
    end if
    H=H-1
    If H=0 then
      If K>1 then H=SizeS else H=1
      goto DoPrev
    End if
    Gosub HiLite: goto DoKeyNext
  end if

  if mid$(C,2,1)=chr$(80) then   ' Down arw
    If Bit(BitShift,1) or Bit(BitShift,4) then ' Left-Alt or Shift?
      H=SizeS: If H>KK then H=KK+1
      gosub HiLite: goto DoKeyNext
    end if
    H=H+1: If H>SizeS or H+K>T then H=1: goto DoNext
    Gosub HiLite: goto DoKeyNext
  end if

  if mid$(C,2,1)=chr$(75) then ChDir "..": H=1: K=1: goto Startup  ' Left arw = ..
  if mid$(C,2,1)=chr$(77) then goto Parse13  ' Right arw = Enter simulation (EDit)
  if mid$(C,2,1)=chr$(62) then goto doglogg  ' F4 = View
  if mid$(C,2,1)=chr$(81) then goto DoNext  ' PageDown
  if mid$(C,2,1)=chr$(73) then goto DoPrev  ' PageUp
  if mid$(C,2,1)=chr$(71) then SFLag="N": H=1: K=1: goto Startup  ' Home/Reset
  if mid$(C,2,1)=chr$(82) then A$="": goto DoCmd  ' Insert
  if mid$(C,2,1)=chr$(60) then C="== ": goto Execit  ' F2=Exec
  if mid$(C,2,1)=chr$(38) then C="cmd /c LTFViewR5U.Exe ==": goto Execit  ' Alt+L=Large 
  if mid$(C,2,1)=chr$(30) then C="cmd /c dvwview \dos\dv3\dvnotea": goto Execit  ' Alt+A=ASCII
  if mid$(C,2,1)=chr$(18) then C="cmd /c dvwview \dos\dv3\dvnotee": goto Execit  ' Alt+E=Electronics
  if mid$(C,2,1)=chr$(37) then C="cmd /c dvwview \dos\dv3\dvnotek": goto Execit  ' Alt+K=Scans
  if mid$(C,2,1)=chr$(19) then C="cmd /c dvwview \dos\dv3\dvnoter": goto Execit  ' Alt+R=Resistors
  if mid$(C,2,1)=chr$(17) then C="cmd /c dvwview \dos\dv3\dvnotew": goto Execit  ' Alt+W=Wire
  if mid$(C,2,1)=chr$(35) then shell "cmd /c dvwhelp": goto Startup  ' Alt+H=DVWHelp.Bat
  if mid$(C,2,1)=chr$(47) then shell "Cmd /T:1F /K Cls & Set|more & Ver": goto EndMark  ' Alt+V=VTerm
  if mid$(C,2,1)=chr$(44) then shell "cmd /c dvwuserz": goto Startup  ' Alt+Z=DVWUserZ.Bat
  if mid$(C,2,1)=chr$(34) then gosub DVWGen: goto Startup ' Alt+G=Generate DVWin
  if mid$(C,2,1)=chr$(46) then gosub colortab: goto startup ' Alt+C = Colors
  if mid$(C,2,1)=chr$(31) then gosub KeyScan: goto startup ' Alt+S = ScanKeys
  if mid$(C,2,1)=chr$(83) then goto DoKill  ' Delete
  if mid$(C,2,1)=chr$(61) then goto Enditall  ' F3 = Exit
  if mid$(C,2,1)=chr$(45) then goto Enditall  ' Alt+X = Exit
  if mid$(C,2,1)=chr$(79) then K=T-SizeS: goto Startup  ' End
  if mid$(C,2,1)=chr$(66) then goto DoMarked  ' F8=Do marks
  if mid$(C,2,1)=chr$(68) then SFlag="N": goto Startup  ' F10=Name sort
  if mid$(C,2,1)=chr$(87) then SFlag="-D": goto Startup  ' F11=-Date sort
  if mid$(C,2,1)=chr$(88) then SFlag="-S": goto Startup  ' F12=-Size sort
  if mid$(C,2,1)=chr$(63) then SFlag="N /A:R": goto Startup  ' F5=R/O files
  if mid$(C,2,1)=chr$(64) then SFlag="N /A:H": goto Startup  ' F6=Hidden files
  if mid$(C,2,1)=chr$(65) then SFlag="N /A:S": goto Startup  ' F7=System files

  If mid$(C,2,1)=chr$(48) then
    Bell=1-Bell: If Bell=1 then Beep ' Alt+B = Toggle Beep
    goto Startup
  End if

  If mid$(C,2,1)=chr$(16) then
rem    TFlag=1-TFlag: If Bell=1 and TFlag=1 then Beep ' Alt+Q = Toggle ?
rem    goto Startup
  End if

  If mid$(C,2,1)=chr$(25) then
    TFlag=1-TFlag: If Bell=1 and TFlag=1 then Beep ' Alt+P = Toggle Peeking
    goto Startup
  End if

  If mid$(C,2,1)=chr$(20) then
    TimerFlag=1-TimerFlag: If Bell=1 and TimerFlag=1 then Beep ' Alt+T = Toggle Timer
    goto Startup
  End if

  If mid$(C,2,1)=chr$(23) then 
    If instr(DirDataTab(K+H-1),"<DIR>")>0 then 
      If Bell=1 then beep
      goto getfunc
    End if
    C="cmd /c DVWUserI.Bat =="
    goto Execit ' Alt+I = Inspect
  End if

End if  ' end of C-len(2)

If C="+" then shell "cmd /c DVWPlus.Bat": goto Startup ' +=GoldEd+

If C=Chr$(9) then H=H+(SizeS/4): Gosub HiLite: goto GetFunc ' Tab

If len(C)=2 and mid$(C,2,1)=chr$(67) then  ' F9=Drive
 Print "Select DRIVE {";DrvList;"}, or ESC to Abort ";
Getdrv:
 Locate ,36+Len(DrvList)
 A=""

 While A=""
  Gosub DOTOD
  If Instat=0 then Sleep 45 else A=Inkey$
 WEnd

 If A=Chr$(13) then goto Startup
 If A=Chr$(27) then goto Startup
 If len(A)<>1 then gosub mybeep: goto Getdrv
 If Asc(A)>=97 and Asc(A)<=122 then A=Chr$(Asc(A)-32)  ' force Uppercase
 If Asc(A)<65 or Asc(A)>90 then Gosub MyBeep: goto Getdrv
 On Error Resume Next
 ChDrive A
 If Err=76 then Errclear: Gosub MyBeep: Print " *** Error: Drive ";A;": does NOT exist! ";: goto Getdrv
 On Error goto 0
 Goto Startup
End if

If C=" " then  ' Space bar = mark
  If Mid$(DirDataTab(K+H-1),52,1)=" " then
    Mid$(DirDataTab(K+H-1),52,1)=chr$(251)
   else
    Mid$(DirDataTab(K+H-1),52,1)=" "
  End if
  If H<SizeS and H+K<T then H=H+1
  Gosub HiLite
 goto GetFunc
End if

if C=chr$(13) then  ' ENTER key = ChDir if <DIR>, else Edit
Parse13:
 If T=1 then goto Startup
 A=Trim$(Mid$(DirDataTab(K+H-1),53))
 Z=Trim$(Mid$(DirDataTab(K+H-1),40,12))

 If Instr(DirDataTab(K+H-1),"<DIR>")>0 then
   ChDir A: H=1: K=1
   Goto Startup
  Else
   If Z<>"" then A=Z  ' prefer SFN
   Shell "Cmd /c "+EFlag+A  'Edit file
  goto Startup
 End if  
End if

if C=chr$(10) then  ' Ctrl+ENTER key = Win Start or ChDir
Parse10:
 If T=1 then goto Startup
 A=Trim$(Mid$(DirDataTab(K+H-1),53))
 Z=Trim$(Mid$(DirDataTab(K+H-1),40,12))

   If Z<>"" then
     A=chr$(34)+A+chr$(34)+" "+Z  ' prefer SFN with LFN Title
   end if
   Shell "cmd /c start "+A  ' Win Start file
   goto Startup
End if

If C=Chr$(27) then
 If SubDir="C:\" then goto ENDITALL
 ChDir "..": H=1: K=1: goto Startup
End if

If len(C)=2 then gosub MyBeep: goto GetFunc

A$=C$
Goto docmd ' start typing, first char re-keyed (A$)

Goto ENDITALL ' trap, never gets here

'* * * * * * * * * * * * * * * * Sub-routines * * * * * * * * * * * * * * * *
'* * * * * * * * * * * * * * * * Sub-routines * * * * * * * * * * * * * * * *
'* * * * * * * * * * * * * * * * Sub-routines * * * * * * * * * * * * * * * *

MyBeep:
  sleep 250: beep
  sleep 250: beep
  sleep 250: beep
Return

ScrDump:
  Console Get Screen to MaxRow, MaxCol
  Open "C:\$ScrDump.txt" for output as #2

  FOR Row = 1 TO MaxRow

     FOR Column = 1 TO MaxCol
        ConText += CHR$(SCREEN(Row,Column))
     NEXT Column

  Print #2,ConText
  ConText=""
  NEXT Row

  Close #2
  If Bell=1 then Shell "Cmd /c Beep"
Return

DoAttr:
    Saveit=A
    A=Trim$(Mid$(Saveit,53))
    Z=Trim$(Mid$(Saveit,40,12))
    If Z<>"" then A=Z

    FAttr=GetAttr(A): A=Saveit
    CX=CURSORX
    If CX<78 then Color Yellow: Print string$(78-CX,250);
    Print "  ";

    AC=CursorX
    If (FAttr and 32)=32 then Color White: Print "A"; else Color Yellow: Print chr$(250);
    If (FAttr and 1)=1 then Color HYellow: Print "R"; else Color Yellow: Print chr$(250);
    If (FAttr and 2)=2 then Color Red: Print "H"; else Color Yellow: Print chr$(250);
    If (FAttr and 4)=4 then Color HRed: Print "S"; else Color Yellow: Print chr$(250);

    If (FAttr and 2)=0 and (FAttr and 4)=0 and (FAttr and 1)=1 then
      Locate ,AC+1: Color HYellow: Print "R/O";
    End if
    If (FAttr and 1)=0 and (FAttr and 4)=0 and (FAttr and 2)=2 then
      Locate ,AC+1: Color Red: Print "Hid";
    End if

    If instr(A,"<DIR>")>0 then Color Yellow else Color White
Return

DVWGen:
  If not isfile("dvwgen.bat") then gosub MyBeep: return  ' Alt+G = Gen/Build DVWin.Bas
  Shell "cmd /c start dvwgen.bat"
  Goto Enditall
Return

DoNext:
  B=1
  I=K+SizeS
  If I>=T Then I=1
  Goto NextScr

DoPrev:
  B=1
  If K>SizeS then I=K-SizeS else I=1
  Goto NextScr

PeekBas:  ' Alt+P (0,25) toggles

 A=ucase$(DirDataTab(K+H-1))
 If Instr(A,"<DIR>")>0 then return

 FTTMax=len(FTTab)/4
 For FTTIdx=1 to FTTMax
   If instr(A,mid$(FTTab,((FTTIdx-1)*4)+1,4))>0 then goto PeekOk
 Next FTTIdx

 Print string$(TCol*7," ");
 Locate SizeS+9,1
 Return

PeekOk:
 A=Trim$(Mid$(DirDataTab(K+H-1),53)): ZZ=A  ' LFN
 Z=Trim$(Mid$(DirDataTab(K+H-1),40,12))
 If Z<>"" then A=Z  ' Prefer SFN
 Open A for input as #1

 Print string$(TCol*7," ");
 Locate SizeS+9,1
 Color HGreen,Black
 Print "  File: ";mid$(ZZ,1,TCol-9);" "

 For L=1 to 6
Peekskip:
   Line input#1,A
   If not eof(1) and (A="" or A=" ") then goto Peekskip
   If A<>"" then
     Locate SizeS+9+L,1
     Print "    ";mid$(A,1,TCol-5);" ";
   End if
   If eof(1) and L<6 then
     locate CursorY+1,1: print " -=:{ EoF }:=- ";: L=6
   End if
Peekend:
 Next L

 Close 1
 Color White,Blue
Return

DoGlogg:  ' F4 = View file
 A=Trim$(Mid$(DirDataTab(K+H-1),53))
 Z=Trim$(Mid$(DirDataTab(K+H-1),40,12))

 If Instr(DirDataTab(K+H-1),"<DIR>")>0 then
   Beep
   Goto Startup
  Else
   If Z<>"" then A=Z
   Shell "Cmd /c "+VFlag+A
  goto Startup
 End if  
Return

DoMarked:

Locate CursorY,1: CY=CursorY
Print space$(TCol*5);
Locate CY+1,1
Print "Notes: == will INSERT each Marked directory/file NAME(s) in the current line (i.e. COPY == ==2 or DEL ==) "
Print "DOS command? {or ENTER to Abort} "
Print
Print " > ";

CX=CURSORX: CY=CURSORY
If (TCol*2)-3 > 255 then buffer=space$(255) else buffer=space$((TCol*2)-3)

retVal = TextInput(TCol, CurFile, buffer, CY, CX, history1())

C=Trim$(buffer)
If C="" goto Startup

CC=C
II=1
Cls

NxtMark:
While II<T and mid$(DirDataTab(II),52,1)=" ": II=II+1: WEnd
If II=T goto EndMark

C=CC
While instr(C,"==")>0
  L=instr(C,"==")
  B=II  ' Current line
  If B<=0 or B>=T then goto Startup  ' Abort, bad Rec #

  A=DirDataTab(B)
  If len(A)>39 and mid$(A,40,1)<>" " then A=trim$(mid$(A,40,12)) _ ' Prefer SFN
   else If len(A)>52 and mid$(A,53,1)<>" " then A=mid$(A,53) else A=""  ' Extract LFN
  If A="" then II=II+1: goto NxtMark

  Z=mid$(C,L+2)
  C=mid$(C,1,L-1)+A+Z
wend  

Color White: Print "Executing [";
Color HYellow: Print C;
Color White: Print "] ..."
Shell "Cmd /c "+C
II=II+1
Goto NxtMark

EndMark:
Print
Color Yellow: Print String$(TCol,"_")
Color HWhite: If Bell=1 then Beep

Print " Press {ENTER} to continue";
Print " or {D} to Dump screen to C:\$ScrDump.Txt ";

Pauseagain2:
A=""
While A="": If Instat then A=Inkey$ else Sleep 45: WEnd
If A<>$CR and A<>"d" and A<>"D" then Beep: goto Pauseagain2

If A="d" or A="D" then gosub ScrDump
Color White: A=""

Goto Startup

DoHelp:

  Locate RLeg+3,3
  Print space$(L);" ";

  Color KeyCo: Print "Alt+A";: Color Black: Print "=ASCII ";
  Color KeyCo: Print "+C";: Color Black: Print "=Colors ";
  Color KeyCo: Print "+E";: Color Black: Print "=Electronics ";
  Color KeyCo: Print "+H";: Color Black: Print "=DVWHelp ";
  Color KeyCo: Print "+K";: Color Black: Print "=Kybd-Codes ";
  Color KeyCo: Print "+R";: Color Black: Print "=Resistors ";
  Color KeyCo: Print "+S";: Color Black: Print "=Scan-Codes ";
  Color KeyCo: Print "+W";: Color Black: Print "=Wire ";
  Color KeyCo: Print "+Z";: Color Black: Print "=DVWUserZ ";
  Color KeyCo: Print "+";chr$(24);: Color Black: Print "=Top ";
  Color KeyCo: Print "+";chr$(25);: Color Black: Print "=Bottom ";

  Locate RLeg+4,3
  Print space$(L);"   ";

  Color KeyCo: Print "Alt+P";: Color Black: Print "=Peek ";
  If TFlag=1 then Color HGreen,Black: Print "On";: Color Black,Cyan: Print "/Off";
  If TFlag=0 then color Black,Cyan: Print "On/";: Color Red: Print "Off";
  Color Black,Cyan: Print " ";

  Color KeyCo: Print "+B";: Color Black: Print "=Beep ";
  If Bell=1 then Color HGreen,Black: Print "On";: Color Black,Cyan: Print "/Off";
  If Bell=0 then color Black,Cyan: Print "On/";: Color Red: Print "Off";
  Color Black,Cyan: Print " ";

  Color KeyCo: Print "+T";: Color Black: Print "=Timer ";
  If TimerFlag=1 then Color HGreen,Black: Print "On";: Color Black,Cyan: Print "/Off";
  If TimerFlag=0 then color Black,Cyan: Print "On/";: Color Red: Print "Off";
  Color Black,Cyan: Print " ";

  Color KeyCo: Print "+G";: Color Black: Print "=dvwGen ";
  Color KeyCo: Print "+I";: Color Black: Print "=Inspect ";

  Color KeyCo: Print "Ctrl+Enter";: Color Black: Print "=Start or CD   ";
  Color Black: Print chr$(192);chr$(16);: Color Red: Print ZDesc;"  ";
  Color KeyCo: Print "+X";: Color Black: Print "=eXit    "; 

 Return

DoKill:
 L=instr(DirDataTab(K+H-1),"<DIR>")
 If L>0 then Beep: goto Getfunc

 A=Trim$(Mid$(DirDataTab(K+H-1),53))  ' Parse LFN
 C=A
 Z=Trim$(Mid$(DirDataTab(K+H-1),40,12))  ' Parse SFN
 If Z<>"" then A=Z  ' Prefer SFN

 Color Red,Black: Print "Delete";
 Color White: Print " file ";
 Color HCyan: Print C;
 Color White: Print " {";
 Color HCyan: Print Z;
 Color White: Print "} ";
 Color HCyan: Print "???";
 Color White: Print " [Y=Yes] ";
 C=Waitkey$
 If C="y" or C="Y" then Kill A else Beep
goto Startup

HiLite:

 If H<1 then H=1
 If H>SizeS then H=SizeS
 If DirDataTab(K+H-1)="::EOF" or K+H-1>=T then K=(int(T/SizeS)*SizeS)+1: goto Startup

 If HH>=1 and HH<=SizeS and K+HH-1<T then  ' Undo HiLite
  Locate FstData+HH,1
  Color White,Blue
  Print Space$(TCol);
  Locate FstData+HH,1
  F=DirDataTab(K+HH-1)
  Color Yellow
  Print chr$(186);
  If instr(F,"<DIR>")>0 then Color Yellow else Color White
  Print " ";Using$("####",K+HH-1);
  If instr(F,"<DIR>")>0 then Color HCyan else Color HWhite
  Print "  ";

  If len(F)>=TCol-20 then Print mid$(F,1,TCol-22);: else Print F;
  Color Yellow
  If len(F)<TCol-20 and LLen<TCol-20 then 
    Print string$(LLen-len(F),250);
   Else
    Print string$(TCol-22-len(F),250);
  End if

    A=F
    GoSub DoAttr  ' Display ARHS attributes
    If instr(F,"<DIR>")>0 then Color Yellow else Color White
    Print "  ";Using$("####",K+HH-1);
    Color Yellow: Locate ,TCol: print chr$(186);
  Color White
 End if

Redoit:  ' HILite current line
 Locate FstData+H,1
 Color HYellow,Cyan
 Print Space$(TCol);
 Locate FstData+H,1
 Print chr$(186);" ";Using$("####",K+H-1);
 F=DirDataTab(K+H-1)
 Print "  ";
 CurFile=F

  If len(F)>=TCol-20 then Print mid$(F,1,TCol-22);: else Print F;
  If len(F)<TCol-20 and LLen<TCol-20 then 
    Print string$(LLen-len(F),250);
   Else
    Print string$(TCol-22-len(F),250);
  End if

    A=F
    GoSub DoAttr
    Print "  ";Using$("####",K+H-1);
    Color Yellow: locate ,TCol: print chr$(186);

 CY=CursorY
 Locate SizeS+9,1
 Color White,Blue
 If TFlag then
   gosub PeekBas ' Type file ON
'  else
'   Print string$(TCol*7," ");  ' Type OFF
'   Locate RLeg-2,3
'   Color HWhite,Black
'   Print Trim$(Mid$(DirDataTab(K+H-1),53));
 End if

 Color White,Blue
 Locate CY,1

 HH=H  ' Set prev Hilite Row

Return

DoCmd:

Locate CursorY,1: CY=CursorY
Print space$(TCol*5);
Locate CY+1,1
Print "Notes: == Inserts directory/file NAME.EXT in current line,  =. to Insert file NAME.,  .= to Insert file .EXT "
Print "  DOS command? {or ENTER to abort}                          Alt+L Copies LONG File Name to entry area at cursor "
Print
Print " > ";

CX=CURSORX: CY=CURSORY
If (TCol*2)-3 > 255 then buffer=space$(255) else buffer=space$((TCol*2)-3)
If A<>"" then buffer=A+Mid$(buffer,2) ' pass 1st key ...

retVal = TextInput(TCol, CurFile, buffer, CY, CX, history1())
C=Trim$(buffer)

Execit:
If C="" goto Startup
CC=C

If UCase$(mid$(C,1,3))="CD " then Chdir mid$(C,4): Goto Startup
If UCase$(mid$(C,1,6))="CHDIR " then Chdir mid$(C,7): Goto Startup

While instr(C,"==")>0
  L=instr(C,"==")
  B=K+H-1  ' Current line
  If B<=0 then goto Startup  ' Abort, bad Rec #

  If B<T then A=DirDataTab(B) else A=""
  If len(A)>39 and mid$(A,40,1)<>" " then A=trim$(mid$(A,40,12)) _ ' Prefer SFN
   else If len(a)>52 and mid$(A,53,1)<>" " then A=mid$(A,53) else A=""  ' Extract LFN

  Z=mid$(C,l+2): M=instr(Z," ")
  If M>0 then Z=mid$(Z,M) else Z=""
  C=mid$(C,1,L-1)+A+Z
wend  

While instr(C,"=.")>0
  L=instr(C,"=.")
  B=K+H-1  ' Current line
  If B<=0 then goto Startup  ' Abort, bad Rec #

  If B<T then A=DirDataTab(B) else A=""
  If len(A)>39 and mid$(A,40,1)<>" " then A=trim$(mid$(A,40,12)) _ ' Prefer SFN
   else If len(a)>52 and mid$(A,53,1)<>" " then A=mid$(A,53) else A=""  ' Extract LFN
  If A<>"" then
    for ll=len(a) to 1 step -1
      if mid$(a,ll,1)="." then A=mid$(A,1,ll-1): ll=1
    next ll
  End if
  Z=mid$(C,l+2)
  If Z="" then C=mid$(C,1,L-1)+A else C=mid$(C,1,L-1)+A+"."+Z
wend

While instr(C,".=")>0
  L=instr(C,".=")
  B=K+H-1  ' Current line
  If B<=0 then goto Startup  ' Abort, bad Rec #

  If B<T then A=DirDataTab(B) else A=""
  If len(A)>39 and mid$(A,40,1)<>" " then A=trim$(mid$(A,40,12)) _ ' Prefer SFN
   else If len(a)>52 and mid$(A,53,1)<>" " then A=mid$(A,53) else A=""  ' Extract LFN
  If A<>"" then
    for ll=len(a) to 1 step -1
      if mid$(a,ll,1)="." then A=mid$(A,ll+1): ll=1
    next ll
  End if
  Z=mid$(C,l+2)
  C=mid$(C,1,L-1)+"."+A+Z
wend

While instr(C,"::")>0
  L=instr(C,"::")
  B=val(mid$(c,l+2))
  If B=0 then goto Startup  ' Abort, bad Rec #

  If B<T then A=DirDataTab(B) else A=""
  If len(A)>39 and mid$(A,40,1)<>" " then A=trim$(mid$(A,40,12)) _ ' Prefer SFN
   else If len(a)>52 and mid$(A,53,1)<>" " then A=mid$(A,53) else A=""  ' Extract LFN

  Z=mid$(C,l+2): M=instr(Z," ")
  If M>0 then Z=mid$(Z,M) else Z=""
  C=mid$(C,1,L-1)+A+Z
wend  

Cls
Color White: Print " ";TIME$;" Executing  -=:{ ";
Color HYellow: Print C;
Color White: Print " }:=- "

TStore=TIME$
Shell "Cmd /c "+C
EStore=TIME$

If mid$(C,1,3)="cd " or mid$(C,1,3)="CD " then K=1
If mid$(C,1,6)="chdir " or mid$(C,1,6)="CHDIR " then K=1
Color HWhite

Print
Color Yellow: Print chr$(212);string$(TCol-2,chr$(205));chr$(190);
Color HWhite

If Bell=1 then Beep

If TimerFlag and TStore<>EStore then
  TStores=(val(mid$(TStore,1,2))*3600)+(val(mid$(TStore,4,2))*60)
  TStores+=val(mid$(TStore,7,2))
  EStores=(val(mid$(EStore,1,2))*3600)+(val(mid$(EStore,4,2))*60)
  EStores+=val(mid$(EStore,7,2))
  Elapsed=EStores-TStores: ElapMins=0: ElapSecs=Elapsed

  Print "  Runtime Start: ";TStore;"  End: ";EStore;
  If Elapsed >=60 then ElapMins=int(Elapsed/60): ElapSecs=Elapsed-(ElapMins*60)
  Print "  Elapsed: ";: If ElapMins>0 then Print ElapMins;"Min, ";
  Print ElapSecs;"Sec "

  If Elapsed>=Idler and Bell=1 then
    While not instat
      Gosub MyBeep
      Print space$(10);"-=:{ Press any key }:=-";: Locate CursorY,1
      L=Timer+60: while timer<L and not instat: Sleep 45: Wend
    Wend
    Locate CursorY,1: Print space$(40);: Locate CursorY,1
    A=inkey$
  End if
End if

Print " Press {ENTER} to continue";
Print " or {D} to Dump screen to C:\$ScrDump.Txt ";

Pauseagain:
A=""
While A="": If Instat then A=Inkey$ else Sleep 45: WEnd
If A<>$CR and A<>"d" and A<>"D" then Beep: goto Pauseagain

If A="d" or A="D" then gosub ScrDump
Color White: A=""

Goto Startup

Goto ENDITALL

NewScr:
  Color White,Blue
  Cls
  Color Blue,White: Print Space$(TCol*2);
200
  Locate 1,2
  Print PgmVer;
  Color HBlue,White: Locate ,Int((TCol - LEN(PNAME$)) / 2): Print PNAME$;

  Locate 2,TCol-Len(CName)-17
  Color Yellow,White: Print "Machine: ";
  Color HBlue,White: Print CName; 

  Locate 1,1+len(PgmVer)+8
  Color HBlue,White: Print CPUs; 
  Color Yellow,White: Print " CPUs ";

  Locate 2,(TCol-20)/2
  Color Violet: Print " {c} ";mid$(date$,7,4);" Ben Ritchey ";
  Color Blue

  Z=Z+MONTHTAB(VAL(MID$(DATE$,1,2)))+STR$(VAL(MID$(DATE$,4,2)))
  A="th": AA=VAL(MID$(DATE$,4,2))
  IF AA=1 OR AA=21 OR AA=31 THEN A="st"
  IF AA = 2 OR AA = 22 THEN A = "nd"
  IF AA = 3 OR AA = 23 THEN A = "rd"
  Z = Z + A + ", " + MID$(DATE$, 7, 4): AA=127-LEN(Z)
  Locate 1,(TCol-34): Print Z;"  ";: Z=""

  GOSUB DOTOD
  Color White,Blue
 Return

DOTOD:
  CX=CURSORX: CY=CURSORY
  Z=TIME$: AA=VAL(MID$(TIME$, 1, 2))
  IF AA>11 THEN Z=Z+" Pm" ELSE Z=Z+" Am"
  IF AA>12 THEN
    A=MID$(STR$(AA-12),2)
    IF LEN(A)=1 THEN A=" "+A
    MID$(Z,1)=A: A=""
  END IF
   Locate 1,(TCol-13): Color Black,White: PRINT " ";Z;"  ";: Z=""
  LOCATE CY,CX
  Color White,Blue
 RETURN

KeyScan:
  Cls
  Print
       PRINT "Press any key combination ... [Code 13=ENTER] to exit"
ScanNxt:
  A="": Print
       While A="": If InStat then A$=INKEY$ else sleep 45: gosub dotod: WEnd
       IF A$=CHR$(13) THEN return
       IF LEN(A$)=1 THEN 
         Print "  1 byte Scan code: ";
         PRINT "[";ASC(A$);"Dec, ";
         PRINT Hex$(ASC(A$));" Hex, ";chr$(34);A;chr$(34);" ASCII ]"
       End if
       IF LEN(A$)=2 THEN 
         Print "  2 byte Control codes: ";
         PRINT "[";ASC(LEFT$(A$,1));" + ";ASC(RIGHT$(A$,1));"Dec, ";
         PRINT Hex$(ASC(LEFT$(A$,1)));" + ";Hex$(ASC(RIGHT$(A$,1)));" Hex ]"
       End if
       IF LEN(A$)>=3 THEN 
         Print "n/a"
         Print CHR$(7);"* Error: Length = ";Len(A);" bytes!"
       End if
  GOTO ScanNxt
 Return

ColorTab:
cls
Print "Enter Background color (0-15): ";: input AA

Color Black,aa
Print space$(74)

for l=0 to 15
  Color l,aa
  Print " ";string$(72,chr$(219));" "
  Print " ";string$(72,chr$(219));" ";
  Color HWhite,Blue: Print l
  Color l,aa
  Print space$(74)
 next l

Color White,Blue
Print
Print "Press any key ...";
A=""
while A$=""
  Gosub dotod
  If INSTAT then A$=INKEY$ else sleep 45
WEND

return

ENDITALL:
RC=ERR
End RC

REM Month Table Data
DATA January, February, March, April, May, June
DATA July, August, September, October, November, December

END FUNCTION

' TextInput function (c) 2005 Geo Massar with mods by Ben Ritchey

FUNCTION TextInput(TCol as Long, CurFile AS STRING, Buffer AS STRING, _
              Row AS LONG, Col AS LONG, History() AS STRING) AS LONG
  STATIC InsertOff    AS LONG
  LOCAL  BufferLen    AS LONG
  LOCAL  MyKey        AS STRING
  LOCAL  KeyVal       AS LONG
  LOCAL  ColorDefault AS BYTE
  LOCAL  CurPos       AS LONG
  LOCAL  HistoryIdx   AS LONG
  Local A, Z as String
  Local AA, CX, CY, HWhite, Blue, Black, White as Long

  HWhite=15: Blue=1: Black=0: White=7
  BufferLen = LEN(Buffer)
  HistoryIdx = UBOUND(History)                 'index to the empty slot
  ColorDefault = SCREENATTR(CURSORY,CURSORX)
  LOCATE Row, Col : COLOR HWhite, Blue, BufferLen     'bright white against dark blue
  If mid$(Buffer,1,1)<>" " then
    PRINT String$(BufferLen,chr$(249));
    LOCATE Row, Col: print mid$(buffer,1,1);
    CurPos=2: LOCATE Row, Col+1
   else
    PRINT String$(BufferLen,chr$(249));
    CurPos=1: LOCATE Row, Col
  End if

  DO
    MyKey=""
    While MyKey=""
     If Instat=0 then Sleep 45 else MyKey=Inkey$
    WEnd

    SELECT CASE LEN(MyKey)
      CASE 1    : KeyVal = ASC(MyKey)
      CASE 2    : KeyVal = - ASC(MyKey, 2)
      CASE ELSE : ITERATE
    END SELECT

    SELECT CASE KeyVal
      CASE 13, 9  'Enter, Tab
        COLOR ColorDefault MOD 16, ColorDefault \ 16
        FUNCTION = KeyVal
        IF TRIM$(Buffer) = "" THEN EXIT FUNCTION
        HistoryIdx = UBOUND(History)
        IF HistoryIdx > 0 THEN IF Buffer = History(HistoryIdx-1) THEN EXIT FUNCTION
        History(HistoryIdx) = Buffer
        INCR HistoryIdx
        REDIM PRESERVE History(HistoryIdx)
        History(HistoryIdx) = SPACE$(BufferLen)  'new slot for the next entry
        EXIT FUNCTION

      CASE 27  ' ESCape
        If CurPos=1 then 
          If Buffer="" then Exit Function
          LOCATE Row, Col
          PRINT Space$(Len(Buffer));
          Buffer=""
         else
          CurPos=1
        End if

      CASE -72  'Up
        IF HistoryIdx > 0 THEN  DECR HistoryIdx
        Buffer = History(HistoryIdx)
        CurPos = LEN(RTRIM$(Buffer)) + 1

      CASE -80  'Down
        IF HistoryIdx < UBOUND(History) THEN INCR HistoryIdx
        Buffer = History(HistoryIdx)
        CurPos = LEN(RTRIM$(Buffer)) + 1

      CASE -82 'Insert
       IF InsertOff THEN
         InsertOff = 0
         CURSOR ON, 1
       ELSE
         InsertOff = 1
         CURSOR ON, 100
       END IF

      CASE 8 'BackSpace
       IF CurPos > 1 THEN
         DECR CurPos
         Buffer = LEFT$(Buffer, CurPos - 1) & MID$(Buffer, CurPos + 1) & " "
       END IF

      CASE -75 'Left
       IF CurPos > 1 THEN DECR CurPos

      CASE -77 'Right
       IF CurPos < BufferLen THEN INCR CurPos

      CASE -71 'Home
       CurPos = 1

      CASE -79 'End
       CurPos = MIN(LEN(RTRIM$(Buffer)) + 1, BufferLen)

      CASE -83 'Del
       Buffer = LEFT$(Buffer, CurPos - 1) & MID$(Buffer, CurPos + 1) & " "

      CASE -38 'Alt+L = LFN Insert
       IF len(CurFile) > 52 and mid$(CurFile, 53, 1) <> " " then  ' Extract LFN
         MyKey = mid$(CurFile, 53)
        ELSE
         MyKey=""
       END IF
       Buffer = LEFT$(Buffer, CurPos - 1) & chr$(34) & MyKey & chr$(34) _
                  & " " & MID$(Buffer, CurPos, BufferLen - CurPos)
       CurPos = CurPos + len(MyKey) + 3

      CASE 32 TO 255 'Valid charaters
       IF InsertOff THEN
         MID$(Buffer, CurPos, 1) = MyKey
       ELSE
         Buffer = LEFT$(Buffer, CurPos - 1) & MyKey & MID$(Buffer, CurPos, BufferLen - CurPos)
       END IF
       IF CurPos < BufferLen THEN INCR CurPos

      CASE ELSE
       ITERATE
    END SELECT

    LOCATE Row, Col
    PRINT Buffer;
    LOCATE Row, Col + CurPos - 1
  LOOP

DOTOD:
  CX=CURSORX: CY=CURSORY
  Z=TIME$: AA=VAL(MID$(TIME$, 1, 2))
  IF AA>11 THEN Z=Z+" Pm" ELSE Z=Z+" Am"
  IF AA>12 THEN
    A=MID$(STR$(AA-12),2)
    IF LEN(A)=1 THEN A=" "+A
    MID$(Z,1)=A: A=""
  END IF
  Cursor OFF
  Locate 1,(TCol-13): Color Black,White: PRINT " ";Z;"  ";: Z=""
  LOCATE CY,CX
  Cursor ON, 100
  Color White,Blue
 RETURN

END FUNCTION

' End of DVWin.Bas
